(script-fu-register
	"script-fu-stereo-compose-5x7-stereo" ; function name
	"Compose 5x7 Stereo" ; menu label
	"Compose 5x7 stereo" ; description
	"Komei Harada" ; author
	"copyright 2009, Komei Harada" ; copyright notice
	"December 27, 2009" ; date created
	"" ; image type that the script works on
)
(script-fu-menu-register "script-fu-stereo-compose-5x7-stereo" "<Image>/Stereo")

(define (script-fu-stereo-compose-5x7-stereo)
	(let*
		(
			(imageList (gimp-image-list))
			(imageWidth 3456)
			(imageHeight (/ (* 3456 7) 5))
			(image1)
			(image2)
			(fileName1)
			(fileName2)
			(newImage)
			(layer)
		)
		(if 
			(> (car imageList) 1)
			(begin
				(set! image1 (vector-ref (car (cdr imageList)) 1))
				(set! fileName1 (car (gimp-image-get-name image1)))
				(if (re-match "\.[Jj][Pp][Gg]$" fileName1)
					(set! fileName1 (substring fileName1 0 (- (string-length fileName1) 4))) ; remove ".jpg"
				)
				(set! image2 (vector-ref (car (cdr imageList)) 2))
				(set! fileName2 (car (gimp-image-get-name image2)))
				(if (re-match "\.[Jj][Pp][Gg]$" fileName2)
					(set! fileName2 (substring fileName2 0 (- (string-length fileName2) 4))) ; remove ".jpg"
				)

				(set! newImage (car (gimp-image-new imageWidth imageHeight 0)))
				(set! newLayer (car (gimp-layer-new newImage imageWidth imageHeight RGB-IMAGE "Layer" 100 NORMAL)))
				(gimp-image-add-layer newImage newLayer 0)

				(gimp-selection-all image1)
				(gimp-edit-copy-visible image1)
				(gimp-image-clean-all image1)

				(gimp-edit-paste newLayer TRUE)
				(gimp-floating-sel-anchor (car (gimp-image-get-active-layer newImage)))

				(gimp-image-set-filename newImage (string-append fileName1 "_" fileName2))

				(gimp-display-new newImage)
			)
			(gimp-message "Need 2 stereo pairs")
		)
	)
)
