(script-fu-register
	"script-fu-stereo-compose-images-to-layers" ;function name
	"Images to Layers" ;menu label
	"Compose stereo images to layers" ;description
	"Komei Harada" ;author
	"copyright 2010, Komei Harada" ;copyright notice
	"2010-09-18" ;date created
	"*"
)

(script-fu-menu-register "script-fu-stereo-compose-images-to-layers" "<Image>/Stereo")

(define (script-fu-stereo-compose-images-to-layers)
	(let*
		(
			(imageList (gimp-image-list))
			(imageWidth)
			(imageHeight)
			(image)
			(newImage)
			(layer)
			(leftName)
			(rightName)
		)
		(if 
			(>= (car imageList) 2)
			(begin
				(set! image (vector-ref (car (cdr imageList)) 1))
				(set! imageWidth (car (gimp-image-width image)))
				(set! imageHeight (car (gimp-image-height image)))
				(set! leftName (car (gimp-image-get-name image)))
				(if (re-match "\.[Jj][Pp][Gg]$" leftName)
					(set! leftName (substring leftName 0 (- (string-length leftName) 4))) ; remove ".jpg"
				)
				(gimp-selection-all image)
				(gimp-edit-copy-visible image)
				(gimp-image-clean-all image)

				(set! newImage (car (gimp-edit-paste-as-new)))
				(gimp-layer-set-name (car (gimp-image-get-active-layer newImage)) "LeftEye")

				(set! layer (car (gimp-layer-new newImage imageWidth imageHeight RGB-IMAGE "RightEye" 50 NORMAL)))
				(gimp-image-add-layer newImage layer 0)

				(set! image (vector-ref (car (cdr imageList)) 0))
				(set! rightName (car (gimp-image-get-name image)))
				(if (re-match "\.[Jj][Pp][Gg]$" rightName)
					(set! rightName (substring rightName 0 (- (string-length rightName) 4)))
				)
				(gimp-selection-all image)
				(gimp-edit-copy-visible image)
				(gimp-image-clean-all image)

				(gimp-edit-paste layer TRUE)
				(gimp-floating-sel-anchor (car (gimp-image-get-active-layer newImage)))
				(gimp-image-set-filename newImage (string-append leftName "_" rightName))

				(gimp-display-new newImage)
			)
		)
	)
)
