(script-fu-register
	"script-fu-compose-stereo-cross-eyed" ; function name
	"Compose Stereo Cross-Eyed" ; menu label
	"Compose cross-eyed image"; description
	"Komei Harada"; author
	"copyright 2010, Komei Harada" ; copyright notice
	"2010-09-18" ; date created
	""
	SF-IMAGE "Image" 0

)
(script-fu-menu-register "script-fu-compose-stereo-cross-eyed" "<Image>/Stereo")

(define (script-fu-compose-stereo-cross-eyed inputImage)
	(let* ()
		(script-fu-compose-stereo inputImage FALSE)
	)
)

(script-fu-register
	"script-fu-compose-stereo-parallel" ; function name
	"Compose Stereo Parallel" ; menu label
	"Compose parallel image"; description
	"Komei Harada"; author
	"copyright 2009, Komei Harada" ; copyright notice
	"December 27, 2009" ; date created
	""
	SF-IMAGE "Image" 0
)
(script-fu-menu-register "script-fu-compose-stereo-parallel" "<Image>/Stereo")

(define (script-fu-compose-stereo-parallel inputImage)
	(let* ()
		(script-fu-compose-stereo inputImage TRUE)
	)
)

(define (script-fu-compose-stereo inputImage parallel)
	(let*
		(
			(imageList (gimp-image-list))
			(image inputImage)
			(imageWidth)
			(imageHeight)
			(layerList)
			(leftLayer)
			(rightLayer)
			(fileName)

			(newImage)
			(newLayer)
			(floatingLayer)
		)
		(if 
			(> (car imageList) 0)
			(begin
;				(set! image (vector-ref (car (cdr imageList)) 0))
				(set! layerList (gimp-image-get-layers image))
				(if
					(= (car layerList) 2)
					(begin
						(set! imageWidth (car (gimp-image-width image)))
						(set! imageHeight (car (gimp-image-height image)))
						(set! leftLayer (vector-ref (car (cdr layerList)) 1))
						(set! rightLayer (vector-ref (car (cdr layerList)) 0))
						(set! fileName (car (gimp-image-get-name image)))
						(if (re-match "\.[Jj][Pp][Gg]$" fileName)
							(set! fileName (substring fileName 0 (- (string-length fileName) 4))) ; remove ".jpg"
						)

						(set! newImage (car (gimp-image-new (* imageWidth 2) imageHeight 0)))

						(set! newLayer (car (gimp-layer-new newImage imageWidth imageHeight RGB-IMAGE "A" 100 NORMAL)))
						(gimp-image-add-layer newImage newLayer 0)

						(gimp-edit-copy (if (= parallel TRUE) leftLayer rightLayer))
						(gimp-edit-paste newLayer TRUE)

						(set! newLayer (car (gimp-layer-new newImage imageWidth imageHeight RGB-IMAGE "B" 100 NORMAL)))
						(gimp-image-add-layer newImage newLayer 0)
						(gimp-edit-copy (if (= parallel TRUE) rightLayer leftLayer))
						(gimp-edit-paste newLayer TRUE)

						(gimp-floating-sel-anchor (car (gimp-image-get-active-layer newImage)))
						(gimp-layer-translate newLayer imageWidth 0)
						
						(gimp-selection-none newImage)

						(gimp-image-set-filename newImage (string-append fileName (if (= parallel TRUE) "_Parallel.jpg" "_CrossEyed.jpg")))

						(gimp-image-flatten newImage)
						(gimp-display-new newImage)
					)
					(gimp-message "Need 2 layers")
				)
			)
			(gimp-message "No image found")
		)
	)
)
