(script-fu-register
	"script-fu-stereo-save-current-layer" ; function name
	"Save Current Layer" ; menu label
	"Save current layer"; description
	"Komei Harada"; author
	"copyright 2010, Komei Harada" ; copyright notice
	"2010-09-19" ; date created
	""
	SF-IMAGE "Image" 0
	SF-STRING "Output folder" "C:\\SaveMe\\DigitalPictures\\Stereo"
)

(script-fu-menu-register "script-fu-stereo-save-current-layer" "<Image>/Stereo")

(define (script-fu-stereo-save-current-layer inputImage inputFolder)
	(let*
		(
			(image inputImage)
			(folder inputFolder)
			(currentLayer)
			(layerName)
			(opacity)
			(fileName)
		)
		(if
			(not (re-match ".*\\" folder))
			(set! folder (string-append folder "\\"))
		)
		(set! currentLayer (car (gimp-image-get-active-layer image)))
		(set! layerName (car (gimp-drawable-get-name currentLayer)))
		(if (re-match "\.[Jj][Pp][Gg]$" layerName)
			(set! layerName (substring layerName 0 (- (string-length layerName) 4))) ; remove ".jpg"
		)
		(set! fileName (string-append "_Layer_" layerName ".jpg"))

		(set! opacity (car (gimp-layer-get-opacity currentLayer)))
		(gimp-layer-set-opacity currentLayer 100)

		(gimp-file-save RUN-NONINTERACTIVE image currentLayer (string-append folder fileName) fileName)

		(gimp-layer-set-opacity currentLayer opacity)
	)
)

; http://wiki.osphoto.org/index.php/Script-fu_Dialog_box