(script-fu-register
	"script-fu-stereo-save-layers" ; function name
	"Save All Layers" ; menu label
	"Save all layers"; description
	"Komei Harada"; author
	"copyright 2011, Komei Harada" ; copyright notice
	"2011-02-28" ; date created
	""
	SF-IMAGE "Image" 0
	SF-STRING "Output folder" "C:\\Stereo"
)

(script-fu-menu-register "script-fu-stereo-save-layers" "<Image>/Stereo")

(define (script-fu-stereo-save-layers inputImage inputFolder)
	(let*
		(
			(image inputImage)
			(folder inputFolder)
			(currentLayer)
			(layers)
			(layerName)
			(opacity)
			(fileName)
			(i)
		)
		(if
			(not (re-match ".*\\" folder))
			(set! folder (string-append folder "\\"))
		)
		(set! layers (gimp-image-get-layers image))
		(set! i 0)
		(while
			(< i (car layers))

			(set! currentLayer (vector-ref (car (cdr layers)) i))
			(set! layerName (car (gimp-drawable-get-name currentLayer)))
			(if (re-match "\.[Jj][Pp][Gg]$" layerName)
				(set! layerName (substring layerName 0 (- (string-length layerName) 4))) ; remove ".jpg"
			)
			(set! fileName (string-append "_Layer_" layerName ".jpg"))

			(set! opacity (car (gimp-layer-get-opacity currentLayer)))
			(gimp-layer-set-opacity currentLayer 100)

			(gimp-file-save RUN-NONINTERACTIVE image currentLayer (string-append folder fileName) fileName)

			(gimp-layer-set-opacity currentLayer opacity)
			(set! i (+ i 1))
		)
	)
)

; http://wiki.osphoto.org/index.php/Script-fu_Dialog_box