(script-fu-register
	"script-fu-stereo-save-left-right" ; function name
	"Save Left Right" ; menu label
	"Save left and right images"; description
	"Komei Harada"; author
	"copyright 2010, Komei Harada" ; copyright notice
	"2010-09-18" ; date created
	""
	SF-IMAGE "Image" 0
	SF-STRING "Output folder" ""
)

(script-fu-menu-register "script-fu-stereo-save-left-right" "<Image>/Stereo")

(define (script-fu-stereo-save-left-right inputImage inputFolder)
	(let*
		(
			(image inputImage)
			(folder inputFolder)
			(imageList (gimp-image-list))
			(layerList)
			(leftLayer)
			(rightLayer)
			(fileName)
			(newImage)
		)
		(if
			(not (re-match ".*\\" folder))
			(begin
				(set! folder (string-append folder "\\"))
			)
		)
		(if 
			(> (car imageList) 0)
			(begin
;				(set! image (vector-ref (car (cdr imageList)) 0))
				(set! layerList (gimp-image-get-layers image))
				(if
					(= (car layerList) 2)
					(begin
						(set! leftLayer (vector-ref (car (cdr layerList)) 1))
						(set! rightLayer (vector-ref (car (cdr layerList)) 0))
						(set! fileName (car (gimp-image-get-name image)))
						(if (re-match "\.[Jj][Pp][Gg]$" fileName)
							(set! fileName (substring fileName 0 (- (string-length fileName) 4))) ; remove ".jpg"
						)

						(gimp-layer-set-opacity rightLayer 100)

						(gimp-file-save RUN-NONINTERACTIVE image leftLayer (string-append folder fileName "_Left.jpg") (string-append fileName "_Left.jpg"))
						(gimp-file-save RUN-NONINTERACTIVE image rightLayer (string-append folder fileName "_Right.jpg") (string-append fileName "_Right.jpg"))


						(gimp-layer-set-opacity rightLayer 50)
					)
					(gimp-message "Need 2 layers")
				)
			)
			(gimp-message "No image found")
		)
	)
)

; http://wiki.osphoto.org/index.php/Script-fu_Dialog_box